
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Contact_locationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contact_locations = await db.contact_locations.create(
            {
                id: data.id || undefined,
        
        location_name: data.location_name
        ||
        null
            ,
            
        address: data.address
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        region: data.region
        ||
        null
            ,
            
        country: data.country
        ||
        null
            ,
            
        latitude: data.latitude
        ||
        null
            ,
            
        longitude: data.longitude
        ||
        null
            ,
            
        email: data.email
        ||
        null
            ,
            
        phone_primary: data.phone_primary
        ||
        null
            ,
            
        phone_secondary: data.phone_secondary
        ||
        null
            ,
            
        is_primary: data.is_primary
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return contact_locations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const contact_locationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                location_name: item.location_name
            ||
            null
            ,
            
                address: item.address
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                region: item.region
            ||
            null
            ,
            
                country: item.country
            ||
            null
            ,
            
                latitude: item.latitude
            ||
            null
            ,
            
                longitude: item.longitude
            ||
            null
            ,
            
                email: item.email
            ||
            null
            ,
            
                phone_primary: item.phone_primary
            ||
            null
            ,
            
                phone_secondary: item.phone_secondary
            ||
            null
            ,
            
                is_primary: item.is_primary
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const contact_locations = await db.contact_locations.bulkCreate(contact_locationsData, { transaction });

        // For each item created, replace relation files
        

        return contact_locations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const contact_locations = await db.contact_locations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.location_name !== undefined) updatePayload.location_name = data.location_name;
        
        
        if (data.address !== undefined) updatePayload.address = data.address;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.region !== undefined) updatePayload.region = data.region;
        
        
        if (data.country !== undefined) updatePayload.country = data.country;
        
        
        if (data.latitude !== undefined) updatePayload.latitude = data.latitude;
        
        
        if (data.longitude !== undefined) updatePayload.longitude = data.longitude;
        
        
        if (data.email !== undefined) updatePayload.email = data.email;
        
        
        if (data.phone_primary !== undefined) updatePayload.phone_primary = data.phone_primary;
        
        
        if (data.phone_secondary !== undefined) updatePayload.phone_secondary = data.phone_secondary;
        
        
        if (data.is_primary !== undefined) updatePayload.is_primary = data.is_primary;
        
        
        updatePayload.updatedById = currentUser.id;

        await contact_locations.update(updatePayload, {transaction});

        
        

        
        

        

        return contact_locations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contact_locations = await db.contact_locations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of contact_locations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of contact_locations) {
                await record.destroy({transaction});
            }
        });


        return contact_locations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const contact_locations = await db.contact_locations.findByPk(id, options);

        await contact_locations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await contact_locations.destroy({
            transaction
        });

        return contact_locations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const contact_locations = await db.contact_locations.findOne(
            { where },
            { transaction },
        );

        if (!contact_locations) {
            return contact_locations;
        }

        const output = contact_locations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.location_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contact_locations',
                        'location_name',
                        filter.location_name,
                    ),
                };
            }
            
            if (filter.address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contact_locations',
                        'address',
                        filter.address,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contact_locations',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.region) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contact_locations',
                        'region',
                        filter.region,
                    ),
                };
            }
            
            if (filter.country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contact_locations',
                        'country',
                        filter.country,
                    ),
                };
            }
            
            if (filter.email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contact_locations',
                        'email',
                        filter.email,
                    ),
                };
            }
            
            if (filter.phone_primary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contact_locations',
                        'phone_primary',
                        filter.phone_primary,
                    ),
                };
            }
            
            if (filter.phone_secondary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contact_locations',
                        'phone_secondary',
                        filter.phone_secondary,
                    ),
                };
            }
            

            
            

            
            if (filter.latitudeRange) {
                const [start, end] = filter.latitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    latitude: {
                    ...where.latitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    latitude: {
                    ...where.latitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.longitudeRange) {
                const [start, end] = filter.longitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    longitude: {
                    ...where.longitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    longitude: {
                    ...where.longitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_primary) {
                where = {
                    ...where,
                is_primary: filter.is_primary,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.contact_locations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'contact_locations',
                        'location_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.contact_locations.findAll({
            attributes: [ 'id', 'location_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['location_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.location_name,
        }));
    }

    
};

